"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var api_1 = require("../util/api");
var Application = (function () {
    function Application(options) {
        this.client = options.client;
        this.api = this.client;
    }
    Application.prototype.whenEvent = function (event, task) {
        return __awaiter(this, void 0, void 0, function () {
            var stream;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.startService(event.serviceID)];
                    case 1:
                        _a.sent();
                        return [4, this.startService(task.serviceID)];
                    case 2:
                        _a.sent();
                        stream = this.client.listenEvent({
                            serviceID: event.serviceID,
                            eventFilter: event.filter || '*'
                        });
                        stream.on('data', function (_a) {
                            var eventKey = _a.eventKey, eventData = _a.eventData;
                            _this.executeTask(task, eventKey, eventData);
                        });
                        return [2, stream];
                }
            });
        });
    };
    Application.prototype.whenResult = function (result, task) {
        return __awaiter(this, void 0, void 0, function () {
            var stream;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.startService(result.serviceID)];
                    case 1:
                        _a.sent();
                        return [4, this.startService(task.serviceID)];
                    case 2:
                        _a.sent();
                        stream = this.client.listenResult({
                            serviceID: result.serviceID,
                            taskFilter: result.task || '*',
                            outputFilter: result.output || '*'
                        });
                        stream.on('data', function (_a) {
                            var outputKey = _a.outputKey, outputData = _a.outputData;
                            return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0: return [4, this.executeTask(task, outputKey, outputData)];
                                        case 1:
                                            _b.sent();
                                            return [2];
                                    }
                                });
                            });
                        });
                        return [2, stream];
                }
            });
        });
    };
    Application.prototype.executeTask = function (task, key, data) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.client.executeTask({
                serviceID: task.serviceID,
                taskKey: task.taskKey,
                inputData: JSON.stringify(typeof task.inputs === 'function'
                    ? task.inputs(key, JSON.parse(data))
                    : task.inputs || {})
            }, api_1.handleAPIResponse(resolve, reject));
        });
    };
    Application.prototype.startService = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var e_1;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4, new Promise(function (resolve, reject) {
                                _this.client.startService({ serviceID: id }, api_1.handleAPIResponse(resolve, reject));
                            })];
                    case 1:
                        _a.sent();
                        return [3, 3];
                    case 2:
                        e_1 = _a.sent();
                        throw new Error("Error while starting service " + e_1);
                    case 3: return [2];
                }
            });
        });
    };
    return Application;
}());
exports.default = Application;
//# sourceMappingURL=application.js.map