"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var client_1 = require("./client");
var service_1 = require("./service");
var application_1 = require("./application");
var fs = require("fs");
var YAML = require("js-yaml");
var token = process.env.MESG_TOKEN;
var ymlPath = './mesg.yml';
var endpoint = process.env.MESG_ENDPOINT;
var endpointTCP = process.env.MESG_ENDPOINT_TCP || 'localhost:50052';
var service = function () {
    var mesgConfig = YAML.safeLoad(fs.readFileSync(ymlPath));
    return new service_1.default({
        token: token,
        mesgConfig: mesgConfig,
        client: new client_1.default({
            endpoint: endpointTCP,
        }).service(),
    });
};
exports.service = service;
var application = function () {
    return new application_1.default({
        token: token,
        client: new client_1.default({
            endpoint: endpoint,
        }).core(),
    });
};
exports.application = application;
//# sourceMappingURL=index.js.map